#include <math.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

struct matrice {
                double *a;
                int  r;
                int  c;
               };


struct matrice *new_mat(int righe, int colonne)
{
  int i;
  struct matrice *m;
  // unsigned int *tmp;
  //double *temp;
  m = (struct matrice*)calloc(1,sizeof(struct matrice));
  // printf("righe=%d colonne=%d indirizzo struttura=%x\n",righe,colonne,m);
  m->r = righe;
  m->c = colonne;
  m->a = (double *)calloc(righe*colonne,sizeof(double));
  // printf("indirizzo=%x\n",m->a);
  for (i = 0 ; i < righe*colonne ; m->a[i++] = 0.);
  //tmp = (unsigned int *)m;
  //printf("%x %x %x \n",*tmp,*(tmp+1),*(tmp+2));
  //temp = m->a;
  //printf("%lg %lg %lg\n",temp[0],temp[1],temp[2]);
  return m;
}

void print_mat(struct matrice *m,char *nome)
{
  int i,j;
 printf("%s\n",nome);
  for (i = 0 ; i < m->r ; i++)
    for (j = 0 ; j < m->c ; j++)
      {
	double val;
	GetElem(m,i,j,&val);
        printf("%lg%c",val,j == (m->c - 1) ? '\n' : ' ');
	}
   printf("\n");
}
int PutElem(struct matrice *m,int i,int j,double val)
{
  if ((i >= 0 && i < m->r) && (j >= 0 && j < m->c))
        m->a[i*m->c+j] = val;
  else
    return -1;
  return 0;
}

int GetElem(struct matrice *m,int i,int j,double *val)
{
  if ((i >= 0 && i < m->r) && (j >= 0 && j < m->c))
        *val = m->a[i*m->c+j];
  else
    return -1;
  return 0;
}

struct matrice *m_1(struct matrice *m)
{
  int i,j,k,l,n;
  struct matrice *inv, *b;
  if (m->r != m->c) return NULL;
  inv = new_mat(m->r,m->r);
  n=m->r;
  for (i = 0 ; i < m->r ; i++)
    for (j = 0 ; j < m->r ; j++)
      if (i == j)
        PutElem(inv,i,j,1.);

  b = new_mat(m->r,m->r);
  for (i = 0 ; i < m->r ; i++)
    for (j = 0 ; j < m->r ; j++)
      PutElem(b,i,j,m->a[i*m->c+j]);


  for (i = 0 ; i < n ; i++)
    { 
      double val;
      val = b->a[i*n+i];
      if (fabs(val) <= 1.e-100) return 0;
      for (j = 0 ; j < n ; j++)
	{
        inv->a[i*n+j] /= val;
         b->a[i*n+j] /= val;
	}
      for (k = 0 ; k < n ; k++)
	{
          if (k != i)
	    {
             for (j = 0 ; j < n ; j++)
	      {
                inv->a[k*n+j] -= b->a[k*n+i]*inv->a[i*n+j];
	      }
            for (j = 0 ; j < n ; j++)
	      { 
		if (j != i)
                  b->a[k*n+j] -= b->a[k*n+i]*b->a[i*n+j];
	      }
            b->a[k*n+i]=0;
            }
          }
      /*       printf("\n i=%d *************************\n",i);
    printf("\nmatrice b\n ");
    for (l = 0 ; l < n ; l++)
      {
       for (j = 0 ; j < n ; j++)
         printf("%lg ",b->a[l*n+j]);
       printf("\n");
      }
   printf("\nmatrice inv\n ");
    for (l = 0 ; l < n ; l++)
      {
       for (j = 0 ; j < n ; j++)
         printf("%lg ",inv->a[l*n+j]);
       printf("\n");
      }
     
      */
   }
  /*
   printf("\n matrice b\n");  
   for (i = 0 ; i < n ; i++)
     {
      for (j = 0 ; j < n ; j++)
        printf("%lg ",b->a[i*n+j]);
      printf("\n");
     }
   printf("\n matrice inv\n ");
   for (i = 0 ; i < n ; i++)
     {
      for (j = 0 ; j < n ; j++)
        printf("%lg ",inv->a[i*n+j]);
      printf("\n");
     }
  */
  return inv;
}

struct matrice *m_t(struct matrice *m)
{
  int i,j;
  double val;
  struct matrice *t;
  t = new_mat(m->c,m->r);
  for(i=0;i<m->c;i++)
    for(j=0;j<m->r;j++)
      {
       if (GetElem(m,j,i,&val) < 0)
         return 0;
       if (PutElem(t,i,j,val) < 0)
         return 0;
      }
  return t;
}

struct matrice *mx(struct matrice *m, struct matrice *b)

{
/*ra=(righe di a) , cb=(colonne di b),  n=(colonne di a)=(righe di b)*/

  int i,j,k;
  struct matrice *p;
  if (m->c != b->r) return 0;
  p = new_mat(m->r,b->c);

  for(i=0;i<m->r;i++)
   for(j=0;j<b->c;j++)
   {
     double sum;
     sum=0;
     for(k=0;k<m->c;k++)
       sum += m->a[i*m->c+k]*(b->a[k*b->c+j]);
     p->a[i*b->c+j] = sum;
    }
  return p;
}

main()
{
  /* double a[3][3]={5.,7.,10.,
                  6.,3.,11.,
                  1.,4.,5.}; 
   double a[3][3]={1.,2.,3.,
                   4.,5.,6.,
                   7.,8.,9.};
		   double inv[3][3]; 
   if (inverti_matrice(a,inv,3))
   printf("matrice singolare\n"); */
  double tau1,tau2,val;

  int i,j,l,k,m,n,n_par;

  struct matrice *x,*y,*sigmay,*a,*v;
  struct matrice *v_1,*vtheta,*theta;
  double *temp;
  double x1,y1,s1;
  printf("introduci tau1,tau2: ");
  scanf("%d%lg%lg",&n_par,&tau1,&tau2); 
  i = 0;
  while(scanf("%lg%lg%lg",&x1,&y1,&s1) == 3) i++;
  n = i;
  printf("n_punti=%d\n",n);
  lseek(0,0,SEEK_SET);
  x = new_mat(n,1);
  printf("x=%x  \n",x);
  y = new_mat(n,1);
  sigmay = new_mat(n,1);
  scanf("%d%lg%lg",&n_par,&tau1,&tau2); 
  printf("dati input: x,y,sigmay\n");
  printf("tau1=%lg  tau2=%lg\n",tau1,tau2);
  i = 0;
  temp = x->a;
  printf("temp=%x \n",temp);
  printf("%lg %lg\n",temp[0],temp[1]);

  while(scanf("%lg%lg%lg",&(x->a[i]),&(y->a[i]),&(sigmay->a[i])) == 3)
    {
     printf("%d\n",i);
     i++;
    }

  printf("n_punti=%d\n",n);

  a = new_mat(n,n_par);
  v = new_mat(n,n);
  for (i = 0 ; i < n ; i++)
   {
     printf("%d   %lg  %lg+-%lg\n",i,x->a[i],y->a[i],sigmay->a[i]);
     PutElem(a,i,0,1.);
     PutElem(a,i,1,exp(-x->a[i]/tau1)/tau1);
     PutElem(a,i,2,exp(-x->a[i]/tau2)/tau2);
     PutElem(v,i,i,sigmay->a[i]*sigmay->a[i]);
    }
  /*
  Vtheta = (At * Vinv * A)inv
  theta = Vtheta * At * Vinv * y
  
  */
  print_mat(a,"a");
  print_mat(v,"v");
  print_mat(m_1(v),"Vinv");
  print_mat(m_t(a),"At");
  print_mat(mx(m_1(v),a)," Vinv*A");
  print_mat(mx(m_t(a),mx(m_1(v),a)),"At*Vinv*A");
  print_mat(m_1(mx(m_t(a),mx(m_1(v),a))),"(At*Vinv*A)inv");
  print_mat(mx(m_1(v),y)," Vinv*y");
  print_mat(mx(m_t(a),mx(m_1(v),y)),"At*Vinv*y");
  print_mat(mx(m_1(mx(m_t(a),mx(m_1(v),a))),mx(m_t(a),mx(m_1(v),y))),"Vtheta*At*Vinv*y");


  if((v_1 = m_1(v)) == 0)
  {
    printf("matrice sigma singolare \n");
    exit(1);
  }

  if ((vtheta = m_1(mx(m_t(a),mx(v_1,a)))) == 0)
    printf("vtheta matrice singolare ???");

   theta = mx(vtheta,mx(m_t(a),mx(v_1,y))); 
   print_mat(theta,"theta");
}
